<template>
  <ValidationObserver v-slot="{handleSubmit}">
    <CForm
      v-loading="loading"
      class="form-2-col"
      @submit.prevent="handleSubmit(onSubmit)"
    >
      <CCard>
        <CCardHeader>
          <div>
            <font-awesome-icon :icon="['fas', 'plus-circle']" />
            オークションお申込み
          </div>
        </CCardHeader>
        <CCardBody>
          <div class="box-inner-form">
            <div class="row">
              <div class="col-12 col-xl-6">
                <ValidationProvider v-slot="{ errors }" rules="required">
                  <CInput
                    v-model="model.name"
                    type="text"
                    label="お名前"
                    placeholder="お名前"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'user-alt']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>

              <div class="col-12 col-xl-6">
                <ValidationProvider v-slot="{ errors }" rules="required|email">
                  <CInput
                    v-model="model.email"
                    type="text"
                    label="メールアドレス"
                    placeholder="メールアドレス"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'envelope']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-xl-6">
                <ValidationProvider v-slot="{ errors }" rules="required">
                  <CInput
                    v-model="model.phone"
                    type="text"
                    label="電話番号"
                    placeholder="電話番号"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'phone']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>

              <div class="col-12 col-xl-6">
                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label">
                    ご参加
                  </CCol>
                  <CCol sm="9">
                    <ValidationProvider v-slot="{ errors }" rules="required">
                      <app-radio-group
                        v-model="model.participation"
                        :list="PARTICIPATION_LIST"
                        :name="'participation'"
                        :inline="false"
                      />
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </ValidationProvider>
                  </CCol>
                </div>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-xl-6">
                <ValidationProvider v-slot="{ errors }" rules="required">
                  <CInput
                    v-model="model.furigana"
                    type="text"
                    label="フリガナ"
                    placeholder="フリガナ"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'user-alt']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>

              <div class="col-12 col-xl-6">
                <CInput
                  v-model="model.corporateName"
                  type="text"
                  label="法人名"
                  placeholder="法人名"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'building']" class="width-1x" />
                  </template>
                </CInput>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-xl-6">
                <CInput
                  v-model="model.departmentName"
                  type="text"
                  label="部署名"
                  placeholder="部署名"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'suitcase']" class="width-1x" />
                  </template>
                </CInput>
              </div>

              <div class="col-12 col-xl-6">
                <CInput
                  v-model="model.positionName"
                  type="text"
                  label="役職名"
                  placeholder="役職名"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'chart-line']" class="width-1x" />
                  </template>
                </CInput>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-xl-6">
                <ValidationProvider v-slot="{ errors }" rules="required|numeric">
                  <CInput
                    v-model="model.participantNumber"
                    type="number"
                    label="参加人数"
                    placeholder="参加人数"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'users']" class="width-1x" />
                    </template>
                    <template #append-content>
                      名
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>

              <div class="col-12 col-xl-6">
                <ValidationProvider v-slot="{ errors }" rules="required|numeric">
                  <CInput
                    v-model="model.postalCode"
                    type="text"
                    label="郵便番号"
                    placeholder="郵便番号"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'map-pin']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-xl-6">
                <ValidationProvider v-slot="{ errors }" rules="required">
                  <CInput
                    v-model="model.address"
                    type="text"
                    label="ご住所"
                    placeholder="ご住所"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'map-marker-alt']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>

              <div class="col-12 col-xl-6">
                <CInput
                  v-model="model.fax"
                  type="text"
                  label="FAX番号"
                  placeholder="FAX番号"
                  horizontal
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'fax']" class="width-1x" />
                  </template>
                </CInput>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-lg-6" />
              <div class="col-12 col-xl-6">
                <CTextarea
                  v-model="model.note"
                  label="備考"
                  placeholder="備考"
                  horizontal
                  rows="3"
                  class="custom-prepend-textarea"
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'sticky-note']" class="width-1x" />
                  </template>
                </CTextarea>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-xl-6">
                <div role="group" class="form-group form-row mb-1">
                  <div class="col-form-label col-sm-3">
                    本人確認書類（個人）（表面）
                  </div>
                  <div class="col-sm-9">
                    <ValidationProvider v-slot="{ errors }" rules="required">
                      <input v-model="model.frontIvdPath" type="hidden">
                      <CInputFile
                        custom
                        class="form-group"
                        placeholder="ファイルを選ぶ"
                        @change="uploadFile($event, FRONT_IVD)"
                      >
                        <template #invalid-feedback>
                          <div class="d-block invalid-feedback">
                            {{ errors[0] }}
                          </div>
                        </template>
                      </CInputFile>
                    </ValidationProvider>
                  </div>
                </div>

                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label" />
                  <CCol sm="9">
                    <img :src="`http://localhost:8000${model.frontIvdPath}`" alt="">
                  </CCol>
                </div>
              </div>

              <div class="col-12 col-xl-6">
                <div role="group" class="form-group form-row mb-1">
                  <div class="col-form-label col-sm-3">
                    本人確認書類（個人）（裏面）
                  </div>
                  <div class="col-sm-9">
                    <ValidationProvider v-slot="{ errors }" rules="required">
                      <input v-model="model.backIvdPath" type="hidden">
                      <CInputFile
                        custom
                        class="form-group"
                        placeholder="ファイルを選ぶ"
                        @change="uploadFile($event, BACK_IVD)"
                      >
                        <template #invalid-feedback>
                          <div class="d-block invalid-feedback">
                            {{ errors[0] }}
                          </div>
                        </template>
                      </CInputFile>
                    </ValidationProvider>
                  </div>
                </div>

                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label" />
                  <CCol sm="9">
                    <img :src="`http://localhost:8000${model.backIvdPath}`" alt="">
                  </CCol>
                </div>
              </div>
            </div>

            <div class="row">
              <div class="col-12 col-xl-6">
                <div role="group" class="form-group form-row mb-1">
                  <div class="col-form-label col-sm-3">
                    古物許可証（法人）
                  </div>
                  <div class="col-sm-9">
                    <CInputFile
                      custom
                      class="form-group"
                      placeholder="ファイルを選ぶ"
                      @change="uploadFile($event, ANTIQUE_LICENSE)"
                    />
                  </div>
                </div>

                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label" />
                  <CCol sm="9">
                    <img :src="`http://localhost:8000${model.antiqueLicensePath}`" alt="">
                  </CCol>
                </div>
              </div>
            </div>
          </div>
          <div>
            弊社では、オークションにご参加いただくお客様に、ご登録申込フォームへのご記入とご本人確認書類の提出をお願いしております。
            ※法人としてご参加のお客様には、ご登録申込書フォームのご記入、及び古物許可証の添付をお願いしております。
            こちらへの添付が確認できなかった場合は下見会、もしくは当日受付にてご提示いただきます。
            もしご提示がない場合はご参加いただけない仕組みとなっておりますのでご了承ください。
          </div>
        </CCardBody>

        <CCardFooter>
          <CButton
            type="submit"
            color="primary"
          >
            <font-awesome-icon :icon="['fas', 'save']" class="width-1x" />
            同意して次へ進む
          </CButton>

          <CButton
            color="secondary"
            @click="$emit('cancel')"
          >
            キャンセル
          </CButton>
        </CCardFooter>
      </CCard>
    </CForm>
  </ValidationObserver>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import { cloneDeep } from 'lodash'
import { PARTICIPATION_LIST } from '~/constants'
import Member from '~/models/Member'

import AppRadioGroup from '~/components/atoms/AppRadioGroup'

const FRONT_IVD = 'frontIvd'
const BACK_IVD = 'backIvd'
const ANTIQUE_LICENSE = 'antiqueLicense'

export default {
  components: {
    AppRadioGroup
  },

  data () {
    return {
      model: new Member(),
      modelType: 'member',
      loading: false
    }
  },

  computed: {
    /**
     * Save member registration form data to store
     */
    ...mapActions('member/registration', ['setFormData']),

    /**
     * Get PARTICIPATION_LIST
     *
     * @return {Array} PARTICIPATION_LIST
     */
    PARTICIPATION_LIST () {
      return PARTICIPATION_LIST
    },

    /**
     * Return string frontIvd
     *
     */
    FRONT_IVD () {
      return FRONT_IVD
    },

    /**
     * Return string backIvd
     *
     */
    BACK_IVD () {
      return BACK_IVD
    },

    /**
     * Return string antiqueLicense
     *
     */
    ANTIQUE_LICENSE () {
      return ANTIQUE_LICENSE
    },

    /**
     * Get member registration info from store
     */
    ...mapGetters('member/registration', ['formData'])

  },

  mounted () {
    this.prepareData()
  },

  methods: {
    /**
     * Dynamic set model
     *
     */
    setModel () {
      this.model = cloneDeep(this.formData)
    },

    /**
     * Get item detail
     */
    getDetail () {
      this.setModel()
      this.loading = false
    },

    /**
     * Prepare data
     */
    prepareData () {
      this.getDetail(this.formData.id)
    },

    /**
     * Upload file data
     *
     * @param {Array} files - Files upload
     * @param {String } key - Flag fields
     */
    async uploadFile (files, key) {
      const data = new FormData()
      data.append('upload_file', files[0])
      const param = {
        _data: data
      }
      const res = await this.$dam.uploadFile(param)
      if (key === this.FRONT_IVD) {
        this.model.frontIvd = res.data.id
        this.model.frontIvdPath = res.data.path
      } else if (key === this.BACK_IVD) {
        this.model.backIvd = res.data.id
        this.model.backIvdPath = res.data.path
      } else {
        this.model.antiqueLicense = res.data.id
        this.model.antiqueLicensePath = res.data.path
      }
    },

    /**
     * Set model to store
     */
    onSubmit () {
      this.loading = true
      this.setFormData(this.model).then(() => {
        this.$router.push('/member/regist/confirm/')
      })
    }
  }
}
</script>
